<cfscript>
	// the fields current value
	currentValue = attributes.currentValues[fqFieldName];
	// the param structure which will hold all of the fields from the props dialog
	xparams = parameters[fieldQuery.inputID];
	// find if we need to render the simple form field
	renderSimpleFormField = false;
	if ( (StructKeyExists(request, "simpleformexists")) AND (request.simpleformexists EQ 1) )
		renderSimpleFormField = true;
	// load jQuery
	application.facebook.scripts.loadJQuery();
	application.facebook.scripts.loadJQuerySelectboxes();

	//read app config
	appConfig = application.facebook.getAppConfig("facebook");
	//initialize Facebook API
	application.facebook.scripts.loadFacebookJS(true);
	//setup the extended permissions we'll need, in case we show the Login button
	extendedPerms = "manage_pages,publish_stream";
	//read the cookie
	theCookie = application.facebook.fbService.getFacebookCookie();
</cfscript>
<!---<cfparam name="xParams.fbAccessTokenFieldID" default="">
<cfparam name="xParams.fbNameFieldID" default="">
<cfparam name="xParams.fbIDFieldID" default="">--->

<cfif theCookie.success>
	<cfoutput>
		<script>
			// javascript validation to make sure they have text to be converted
			#fqFieldName#=new Object();
			#fqFieldName#.id='#fqFieldName#';
			#fqFieldName#.tid=#rendertabindex#;
			#fqFieldName#.validator="#fqFieldName#validateFields()";
			//#fqFieldName#.msg="Please upload a document.";
			// push on to validation array
			vobjects_#attributes.formname#.push(#fqFieldName#);
/*
			jQuery( function(){
				jQuery("###fqFieldName#setValues").bind("click", function(){
					// retrieve the current value of the selection list
					fbPageID = jQuery("###fqFieldName#").selectedOptions().attr("value");
					// set the values for the fields
					jQuery("###xParams.fbAccessTokenFieldID#").attr("value", fbPages[fbPageID].accessToken);
					jQuery("###xParams.fbNameFieldID#").attr("value", fbPages[fbPageID].name);
					jQuery("###xParams.fbIDFieldID#").attr("value", fbPageID);
				});	
			});
*/
			//fbPages = new Object();
		</script>
		<!--- // determine if this is rendererd in a simple form or the standard custom element interface --->
		<cfscript>
			if ( structKeyExists(request, "element") ) {
				labelText = '<span class="CS_Form_Label_Baseline"><label for="#fqFieldName#">#xParams.label#:</label></span>';
				tdClass = 'CS_Form_Label_Baseline';
			} else {
				labelText = '<label for="#fqFieldName#">#xParams.label#:</label>';
				tdClass = 'cs_dlgLabel';
			}
		</cfscript>
		<tr>
			<td class="#tdClass#" valign="top">#labelText#</td>
			<td class="cs_dlgLabelSmall">
				<select id="#fqFieldName#" name="#fqFieldName#">
					<option value="">Loading Facebook Pages...</option>
				</select>
			</td>
		</tr>
		<tr>
			<td class="#tdClass#" valign="top"><label for:"#fqFieldName#Message">Message:</label></td>
			<td class="cs_dlgLabelSmall">
				<textarea id="#fqFieldName#Message" name="#fqFieldName#Message" cols="40" rows="10"></textarea>
			</td>
		</tr>
		<!--- // include hidden field for simple form processing --->
		<cfif renderSimpleFormField>
			<input type="hidden" name="#fqFieldName#_FIELDNAME" id="#fqFieldName#_FIELDNAME" value="#ReplaceNoCase(fqFieldName, 'fic_','')#">
		</cfif>
		<script type="text/javascript">
			//Go Get the Accounts and look for the correct Access Token
			jQuery.getJSON("https://graph.facebook.com/me/accounts?access_token=#theCookie.access_token#&callback=?", 
				function(json) {
					// clear the current option
					jQuery("###fqFieldName#").children().remove();
					jQuery("###fqFieldName#").append("<option>--Select--</option>");
					
					//loop thru the data and populate the SELECT box
					jQuery.each(json.data, function () {
						/*
						// store the data from the pages into jsObject
						fbPages[this.id] = new Object();
						fbPages[this.id]['accessToken'] = this.access_token;
						fbPages[this.id]['name'] = this.name;
						*/
						
						// create the option values
						optionItem = "<option value='" + this.access_token + "'>" + this.name + "</option>";
						jQuery("###fqFieldName#").append(optionItem);
					});
				}
			);

			//Validate Fields and Post Message to Facebook
			function #fqFieldName#validateFields() {		
				var accessToken = jQuery("###fqFieldName#").selectedOptions().attr("value");
				var message = jQuery("###fqFieldName#Message").val();
				var r = false;
				
				//Those single quotes are breaking the AjaxProxy code...
				message = escapeQuotes(message);
				
				jQuery.ajax({
					url: '#application.adf.ajaxProxy#',
					type: "post",
					async: false,
					data: ({
							bean: 'fbService',
							method: 'postToPage',
							accessToken: accessToken,
							message: message
					  	  }),
					success: function(success) {
					 	if (success == 'true') {
					 		alert('Your message was posted successfully to your Facebook Page.');
					 		console.log('Great success!');
					 		r = true;
					 	} else {
							alert('There was a problem while posting the message to your Facebook Page');
							r = false;
					 	}
					},
					error: function(){
						alert('There was a problem while posting the message to your Facebook Page');
						console.log("FAIL! couldn't call the CFC");
						r = false;
					}
				}); 
				
				return r;
			}

			function escapeQuotes(str) {
				//Replaces the single quote char ' with the apostrophe char ’ (unicode 2019)
				return (str+'').replace(/'/g, '\u2019');
			}
		</script>
	</cfoutput>
<cfelse>
	<cfoutput>
		Please log into Facebook to select the page you want to post to:<br />
		<fb:login-button perms="#extendedPerms#"></fb:login-button>
		<br /><br />
	</cfoutput>
</cfif>